/** @jsx React.DOM */
'use strict'

var React = require('react')
var Reflux = require('reflux')
var reactAsync = require('react-async')

/*

  Isomorphic head element management.

  Supports following sub-elements:
    - link
    - meta
    - title



        <head>
          <title>%react-iso-vgs%</title>
          <link href="http://fonts.googleapis.com/css?family=Merriweather+Sans:800" rel="stylesheet" type="text/css" />
          <link rel="stylesheet" type="text/css" href="http://cdnjs.cloudflare.com/ajax/libs/normalize/3.0.1/normalize.min.css" />
          <link rel="stylesheet" type="text/css" href="/css/style.css" />
        </head>


  var globals = {
    link: [{
      rel: 'stylesheet',
      type: 'text/css',
      href: '/css/style.css'
    },
    {
      rel: 'stylesheet',
      type: 'text/css',
      href: 'http://cdnjs.cloudflare.com/ajax/libs/normalize/3.0.1/normalize.min.css'
    },
    {
      type: 'text/css',
      href: 'http://fonts.googleapis.com/css?family=Merriweather+Sans:800" rel="stylesheet'
    }]
  }


*/


var Head = React.createClass({

  mixins: [reactAsync.Mixin, Reflux.ListenerMixin],

  getInitialStateAsync: function(cb) {
    return cb(null, {
      tmp_data: 'hello_world'
    })
  },

  getContents: function() {
    if(this.state.children) {
      return (
        <title>it worked</title>
      )
    } else {
      return (
        <title>%react-head-content%</title>
      )
    }
  },

  render: function() {
    var contents = this.getContents()
    return (
      <head>
        {contents}
        <link href="http://fonts.googleapis.com/css?family=Merriweather+Sans:800" rel="stylesheet" type="text/css" />
        <link rel="stylesheet" type="text/css" href="http://cdnjs.cloudflare.com/ajax/libs/normalize/3.0.1/normalize.min.css" />
        <link rel="stylesheet" type="text/css" href="/css/style.css" />        
      </head>
    )
  }

})

module.exports = Head